<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_forum.php                                          ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("forum");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_forum.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_forum_href", "admin_forum.php");
	$t->set_var("admin_forum_thread_href", "admin_forum_thread.php");
	$t->set_var("admin_forum_topic_href", "admin_forum_topic.php");
	$t->set_var("admin_forum_settings_href", "admin_forum_settings.php");
	$t->set_var("admin_forum_edit_href", "admin_forum_edit.php");
	$t->set_var("admin_forum_category_href", "admin_forum_category.php");
	
	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_forum.php");
	$s->set_parameters(false, true, true, false);
	$s->set_default_sorting(5, "desc");
	$s->set_sorter("No", "sorter_id", "1", "thread_id");
	$s->set_sorter("Topic", "sorter_topic", "2", "topic");
	$s->set_sorter("Nickname", "sorter_user_name", "3", "user_name");
	$s->set_sorter("Email", "sorter_user_email", "4", "user_email");
	$s->set_sorter("Last Updated", "sorter_modified", "5", "date_modified");

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_forum.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$forum_id = get_param("forum_id");
	$category_id = get_param("category_id");
	$active_forum_id = 0;

	// Show forum categories in the left
	$sql = "SELECT fc.category_id, fc.category_name, fl.forum_id, fl.forum_name ";
	$sql .= " FROM " . $table_prefix . "forum_categories fc LEFT JOIN " . $table_prefix . "forum_list fl ";
	$sql .= " ON fc.category_id = fl.category_id ";
	if ($category_id) {
		$sql .= " WHERE fc.category_id = " . $db->tosql($category_id, INTEGER);
	}
	$sql .= " ORDER BY fc.category_order, fc.category_id, fl.forum_order ";
	$db->query($sql);
	if ($db->next_record()) {
		$current_category = "";
		do {
			if ($db->f("category_name") != $current_category) {
				$t->set_var("list_category_id", $db->f("category_id"));
				$t->set_var("list_category_name", $db->f("category_name"));
				$t->parse("list_category", false);
				$current_category = $db->f("category_name");
				if ($db->f("category_id") == $category_id) {
					$t->set_var("category_id", $category_id);
					$t->set_var("current_category", $current_category);
					$t->parse("current_category_block", false);
				}
				else {
					$t->set_var("current_category_block", "");
				}
			}
			else {
				$t->set_var("list_category", "");
			}
			if ($db->f("forum_id")) {
				if (!$active_forum_id) {
					$active_forum_id = $db->f("forum_id");
				}
				$t->set_var("list_forum_id", $db->f("forum_id"));
				$t->set_var("list_forum_name", $db->f("forum_name"));
				$t->parse("list_forum", false);
			}
			else {
				$t->set_var("list_forum", "");
			}
			$t->parse("list_block", true);
		} while ($db->next_record());
		$t->parse("new_forum_link", false);
		$t->set_var("block_no_categories", "");
	}
	else {
		$t->set_var("new_forum_link", "");
		$t->set_var("block_threads", "");
		$t->set_var("message_list", "There are no categories.");
		$t->parse("block_message", false);
	}

	if (!$forum_id) {
		$forum_id = $active_forum_id;
	}

	// Set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "forum WHERE forum_id = " . $db->tosql($forum_id, INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = get_param("q") > 0 ? get_param("q") : 25;
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;

	// Show threads for selected forum
	if ($forum_id) {
		$forum_name = get_db_value("SELECT forum_name FROM " . $table_prefix . "forum_list WHERE forum_id = " . $db->tosql($forum_id, INTEGER));
		$sql = "SELECT thread_id, topic, user_name, user_email, date_modified FROM " . $table_prefix . "forum ";
		$sql .= " WHERE forum_id = " . $db->tosql($forum_id, INTEGER);
		$sql .= $s->order_by;
		$db->query($sql);
		if ($db->next_record()) {
			do {
				$t->set_var("thread_id", $db->f("thread_id"));
				$t->set_var("topic", htmlspecialchars($db->f("topic")));
				$t->set_var("user_name", htmlspecialchars($db->f("user_name")));
				$t->set_var("user_email", htmlspecialchars($db->f("user_email")));
				$t->set_var("date_modified", va_date($datetime_show_format, $db->f("date_modified", DATETIME)));
				$t->parse("records", true);
			} while ($db->next_record());
			$t->parse("sorters", false);
		} else {
			$t->set_var("sorters", "");
			$t->set_var("message_list", "There are no topics in selected forum.");
			$t->parse("block_message", false);
		}
		$t->set_var("title_block", $forum_name);
		$t->set_var("current_forum", $forum_name);
		$t->parse("current_forum_block", false);

		$admin_forum_topic_url = "admin_forum_topic.php?forum_id=" . urlencode($forum_id) . "&rp=" . urlencode("admin_forum.php?forum_id=" . $forum_id);
		$t->set_var("admin_forum_topic_url", $admin_forum_topic_url);
		$t->parse("forum_links", false);
	}	else {
		$t->set_var("current_forum_block", "");
		$t->set_var("block_threads", "");
		if ($category_id) {
			$t->set_var("message_list", "There are no forums in selected category.");
		}
		else {
			$t->set_var("message_list", "There are no forums in any category.");
		}
		$t->parse("block_message", false);
		$t->set_var("title_block", "No active forum");
		$t->set_var("current_forum_block", "");
		$t->set_var("admin_forum_topic_url", "");
	}

	$t->set_var("title_left_block", "Forums");
	$t->pparse("main");

?>