<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_product.php                                        ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/editgrid.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/date_functions.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");

	check_admin_security("products_categories");

	$currency = get_currency();
	$html_editor = get_setting_value($settings, "html_editor", 1);

	$category_id = get_param("category_id");
	if(!strlen($category_id)) $category_id = "0";

	$content_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

	$generate_serial_values = 
		array( 
			array(0, "don't generate"), array(1, "generate random serial for software product"), array(2, "get serial number from predefined list")
		);



	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_var("css_file", "../styles/" . $settings["style_name"] . ".css");
	$t->set_file("main","admin_product.html");

	$t->set_var("ADD_TO_CART_MSG", ADD_TO_CART_MSG);

	$item_id = get_param("item_id");

	$t->set_var("admin_product_href", "admin_product.php");
	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");
	$t->set_var("admin_order_help_href", "admin_order_help.php");
	$t->set_var("admin_order_statuses_href", "admin_order_statuses.php");
	$t->set_var("date_edit_format", join("", $date_edit_format));
	$t->set_var("html_editor", $html_editor);

	if (intval($item_id)) {
		$t->set_var("product_details_href", $root_folder_path."product_details.php?item_id=$item_id");
		$t->parse("view_live_product", false);
	} else {
		$t->set_var("view_live_product", "");
	}


	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$t->set_var("currency_left", $currency_left);
	$t->set_var("currency_right", $currency_right);
	$t->set_var("currency_rate", $currency_rate);

	$duplicate_properties = get_param("duplicate_properties");
	$duplicate_specification = get_param("duplicate_specification");
	$duplicate_related = get_param("duplicate_related");
	$duplicate_categories = get_param("duplicate_categories");
	$duplicate_images = get_param("duplicate_images");
	$duplicate_accessories = get_param("duplicate_accessories");
	$duplicate_releases = get_param("duplicate_releases");

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	$r = new VA_Record($table_prefix . "items");

	// set up html form parameters
	$r->add_where("item_id", INTEGER);
	$r->change_property("item_id", USE_IN_INSERT, true);
	$r->add_hidden("category_id", INTEGER);

	$item_types = get_db_values("SELECT item_type_id,item_type_name FROM " . $table_prefix . "item_types", array(array("", "")));
	$r->add_select("item_type_id", INTEGER, $item_types, "Product Type");
	$r->parameters["item_type_id"][REQUIRED] = true;
	$r->add_textbox("item_name", TEXT, "Product Name");
	$r->parameters["item_name"][REQUIRED] = true;
	$r->add_textbox("item_order", INTEGER, "Product Order");
	$r->parameters["item_order"][REQUIRED] = true;
	$manufacturers = get_db_values("SELECT manufacturer_id,manufacturer_name FROM " . $table_prefix . "manufacturers", array(array("", "")));
	$r->add_select("manufacturer_id", INTEGER, $manufacturers);
	$r->add_textbox("manufacturer_code", TEXT);
	$r->add_textbox("weight", NUMBER);
	$r->add_textbox("issue_date", DATETIME, "Product Issue Date");
	$r->change_property("issue_date", VALUE_MASK, $date_edit_format);
	$r->add_checkbox("is_showing", INTEGER);
	$r->add_checkbox("is_compared", INTEGER);
	$r->add_checkbox("tax_free", INTEGER);

	$languages = get_db_values("SELECT language_code, language_name FROM " . $table_prefix . "languages", array(array("", "All")));
	$r->add_select("language_code", TEXT, $languages);

	$r->add_checkbox("is_price_edit", NUMBER);
	$r->add_textbox("price", NUMBER, "Price");
	$r->parameters["price"][REQUIRED] = true;
	$r->add_textbox("buying_price", NUMBER, "Buying Price");
	$r->add_textbox("properties_price", NUMBER, "Options Price");

	// appearance
	$r->add_textbox("template_name", TEXT);
	$r->add_checkbox("hide_add_list", INTEGER);
	$r->add_checkbox("hide_add_details", INTEGER);
	$r->add_textbox("preview_url", TEXT);
	$r->add_textbox("preview_width", INTEGER, "Window Preview Width");
	$r->add_textbox("preview_height", INTEGER, "Window Preview Height");

	$r->add_textbox("features", TEXT);
	$r->add_textbox("short_description", TEXT);
	$r->add_radio("full_desc_type", INTEGER, $content_types);
	$r->add_textbox("full_description", TEXT);
	$r->add_textbox("meta_title", TEXT);
	$r->add_textbox("meta_keywords", TEXT);
	$r->add_textbox("meta_description", TEXT);

	$r->add_checkbox("is_special_offer", INTEGER);
	$r->add_textbox("special_offer", TEXT);
	$r->add_textbox("small_image", TEXT);
	$r->add_textbox("small_image_alt", TEXT);
	$r->add_textbox("big_image", TEXT);
	$r->add_textbox("big_image_alt", TEXT);
	$r->add_textbox("super_image", TEXT);

	$r->add_textbox("stock_level", NUMBER);
	$r->add_checkbox("use_stock_level", INTEGER);
	$r->add_checkbox("hide_out_of_stock", INTEGER);
	$r->add_checkbox("disable_out_of_stock", INTEGER);

	$r->add_textbox("sales_price", NUMBER);
	$r->add_textbox("discount_percent", NUMBER);
	$r->add_checkbox("is_sales", INTEGER);
	$r->add_textbox("notes", TEXT);
	$r->add_textbox("buy_link", TEXT);
	$r->add_textbox("votes", INTEGER);
	$r->add_textbox("points", INTEGER);

	// downloadable options
	$r->add_checkbox("downloadable", INTEGER);
	$r->add_textbox("download_period", INTEGER, "Download Period");
	$r->add_textbox("download_path", TEXT, "Path to Downloadable File");
	$r->add_radio("generate_serial", INTEGER, $generate_serial_values);
	$r->add_textbox("activations_number", INTEGER, "Activations Number");

	// set up html form parameters
	$is = new VA_Record($table_prefix . "items_serials", "serials");
	$is->add_where("serial_id", INTEGER);
	$is->add_hidden("item_id", INTEGER);
	$is->change_property("item_id", USE_IN_INSERT, true);
	$is->change_property("item_id", PARSE_NAME, "serial_item_id");

	$is->add_textbox("serial_number", TEXT, "Serial Number");
	$is->parameters["serial_number"][REQUIRED] = true;
	$is->add_checkbox("used", INTEGER);

	$number_serials = get_param("number_serials");
	$is_eg = new VA_EditGrid($is, "serials");
	$is_eg->get_form_values($number_serials);
	
	// notification fields
	$r->add_checkbox("mail_notify", INTEGER);
	$r->add_textbox("mail_to", TEXT);
	$r->add_textbox("mail_from", TEXT);
	$r->add_textbox("mail_cc", TEXT);
	$r->add_textbox("mail_bcc", TEXT);
	$r->add_textbox("mail_reply_to", TEXT);
	$r->add_textbox("mail_return_path", TEXT);
	$r->add_textbox("mail_subject", TEXT);
	$r->add_radio("mail_type", INTEGER, $content_types);
	$r->parameters["mail_type"][DEFAULT_VALUE] = 0;
	$r->add_textbox("mail_body", TEXT);

	$r->add_checkbox("sms_notify", INTEGER);
	$r->add_textbox("sms_recipient", TEXT, "SMS Recipient");
	$r->add_textbox("sms_originator",TEXT, "SMS Originator");
	$r->add_textbox("sms_message",   TEXT, "SMS Message");

	// editing information
	$r->add_textbox("admin_id_added_by", INTEGER);
	$r->change_property("admin_id_added_by", USE_IN_UPDATE, false);
	$r->add_textbox("admin_id_modified_by", INTEGER);
	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("date_modified", DATETIME);

	$r->add_hidden("default_properties", TEXT);

	$times = get_db_values("SELECT shipping_time_id,shipping_time_desc FROM " . $table_prefix . "shipping_times", array(array("", "None")), 90);
	$r->add_select("shipping_in_stock", INTEGER, $times);
	$r->add_select("shipping_out_stock", INTEGER, $times);

	$rules = get_db_values("SELECT shipping_rule_id,shipping_rule_desc FROM " . $table_prefix . "shipping_rules", array(array("", "None")), 90);
	$r->add_select("shipping_rule_id", INTEGER, $rules);

	$r->get_form_values();

	$operation = get_param("operation");
	$current_tab = get_param("current_tab");
	if (!$current_tab) { $current_tab = "general"; }
	$return_page = "admin_items_list.php?category_id=" . $category_id;
	$downloads_errors = "";

	if(strlen($operation))
	{
		if ($operation == "cancel") {
			header("Location: " . $return_page);
			exit;
		} else if($operation == "delete" && $item_id) {
			delete_products($item_id);
			header("Location: " . $return_page);
			exit;
		} else if ($operation == "more_serials") {
			$number_serials += 5;
		} else {

			$is_valid = $r->validate();
			
			if ($is_valid) {
				if(strlen($r->get_value("download_path"))) {
					$r->parameters["download_period"][REQUIRED] = true;
				}
				$record_valid = $r->validate(); 
				$grid_valid = $is_eg->validate();
				$is_valid = ($record_valid && $grid_valid);
				if (!$is_valid) {
					$current_tab = "downloads";
					$downloads_errors = $r->errors;
					$r->errors = "";
				}
			}

			if($is_valid)
			{
				$r->set_value("admin_id_added_by", get_session("session_admin_id"));
				$r->set_value("admin_id_modified_by", get_session("session_admin_id"));
				$r->set_value("date_added", va_time());
				$r->set_value("date_modified", va_time());
				if ($r->is_empty("properties_price")) {
					$r->set_value("properties_price", 0);
				}
	  
				if($operation == "duplicate" && $item_id) {
					// duplicate product with new id 
					$db->query("SELECT MAX(item_id) FROM " . $table_prefix . "items");
					$db->next_record();
					$new_item_id = $db->f(0) + 1;
					$r->set_value("item_name", $r->get_value("item_name") . " (Duplicate)");
					$r->set_value("item_id", $new_item_id);
					$record_updated = $r->insert_record();
					if (!$record_updated) {
						$r->set_value("item_id", "");
					}
	  
					// duplicate product features
					if ($duplicate_specification == 1 && $record_updated) {
						$item_features = array();
						$sql  = " SELECT group_id, feature_name, feature_value FROM " . $table_prefix . "features ";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$sql .= " ORDER BY feature_id ";
						$db->query($sql);
						while ($db->next_record()) {
							$item_features[] = array($db->f("group_id"), $db->f("feature_name"), $db->f("feature_value"));
						}
						for($i = 0; $i < sizeof($item_features); $i++) {
							$group_id = $item_features[$i][0];
							$feature_name = $item_features[$i][1];
							$feature_value = $item_features[$i][2];
							$sql  = " INSERT INTO " . $table_prefix . "features (item_id, group_id, feature_name, feature_value) VALUES (";
							$sql .= $db->tosql($new_item_id, INTEGER) . "," . $db->tosql($group_id, INTEGER) . "," . $db->tosql($feature_name, TEXT) . "," . $db->tosql($feature_value, TEXT) . ")";
							$db->query($sql);
						}
					}
	  
					// duplicate related products
					if ($duplicate_related == 1 && $record_updated) {
						$item_related = array();
						$sql  = " SELECT related_id, related_order FROM " . $table_prefix . "items_related ";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$sql .= " ORDER BY related_order ";
						$db->query($sql);
						while ($db->next_record()) {
							$item_related[] = array($db->f("related_id"), $db->f("related_order"));
						}
						for($i = 0; $i < sizeof($item_related); $i++) {
							$item_related_id = $item_related[$i][0];
							$item_related_order = $item_related[$i][1];
							$sql  = " INSERT INTO " . $table_prefix . "items_related (item_id, related_id, related_order) VALUES (";
							$sql .= $db->tosql($new_item_id, INTEGER) . "," . $db->tosql($item_related_id, INTEGER) . "," . $db->tosql($item_related_order, INTEGER) . ")";
							$db->query($sql);
						}
					}
					
					// duplicate product categories
					if ($duplicate_categories == 1 && $record_updated) {
						$item_categories = array();
						$sql  = " SELECT category_id FROM " . $table_prefix . "items_categories ";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$db->query($sql);
						while ($db->next_record()) {
							$item_categories[] = $db->f("category_id");
						}
						for($i = 0; $i < sizeof($item_categories); $i++) {
							$item_category_id = $item_categories[$i];
							$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id,category_id) VALUES (";
							$sql .= $db->tosql($new_item_id, INTEGER) . ",";
							$sql .= $db->tosql($item_category_id, INTEGER) . ")";
							$db->query($sql);
						}
					} else {
						$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id,category_id) VALUES (";
						$sql .= $db->tosql($new_item_id, INTEGER) . ",";
						$sql .= $db->tosql($category_id, INTEGER) . ")";
						$db->query($sql);
					}
	  
					// duplicate product images
					if ($duplicate_images == 1 && $record_updated) {
						$item_images = array();
						$sql  = " SELECT image_small, small_width, small_height, ";
						$sql .= " image_large, image_title, image_description ";
						$sql .= " FROM " . $table_prefix . "items_images ";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$db->query($sql);
						while ($db->next_record()) {
							$item_images[] = array(
								$db->f("image_small"), $db->f("small_width"), $db->f("small_height"),
								$db->f("image_large"), $db->f("image_title"), $db->f("image_description")
							);
						}
						for($i = 0; $i < sizeof($item_images); $i++) {
							list ($image_small, $small_width, $small_height, $image_large, $image_title, $image_description) = $item_images[$i];
							$sql  = " INSERT INTO " . $table_prefix . "items_images ";
							$sql .= " (item_id, image_small, small_width, small_height, image_large, image_title, image_description) VALUES (";
							$sql .= $db->tosql($new_item_id, INTEGER) . "," . $db->tosql($image_small, TEXT) . ",";
							$sql .= $db->tosql($small_width, INTEGER) . "," . $db->tosql($small_height, INTEGER) . ",";
							$sql .= $db->tosql($image_large, TEXT) . "," . $db->tosql($image_title, TEXT) . "," . $db->tosql($image_description, TEXT) . ")";
							$db->query($sql);
						}
					}
	  
	  
					// duplicate product accessories
					if ($duplicate_accessories == 1 && $record_updated) {
						$item_accessories = array();
						$sql  = " SELECT accessory_id, accessory_order FROM " . $table_prefix . "items_accessories ";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$sql .= " ORDER BY accessory_order ";
						$db->query($sql);
						while ($db->next_record()) {
							$item_accessories[] = array($db->f("accessory_id"), $db->f("accessory_order"));
						}
						for($i = 0; $i < sizeof($item_accessories); $i++) {
							$item_accessories_id = $item_accessories[$i][0];
							$item_accessories_order = $item_accessories[$i][1];
							$sql  = " INSERT INTO " . $table_prefix . "items_accessories (item_id, accessory_id, accessory_order) VALUES (";
							$sql .= $db->tosql($new_item_id, INTEGER) . "," . $db->tosql($item_accessories_id, INTEGER) . "," . $db->tosql($item_accessories_order, INTEGER) . ")";
							$db->query($sql);
						}
					}
	  
					// duplicate all properties
					if ($duplicate_properties == 1 && $record_updated) {
						$item_properties = array();
						$sql  = " SELECT * FROM " . $table_prefix . "items_properties ";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$db->query($sql);
						if ($db->next_record()) {
							do {
								$item_properties[] = array($db->f("property_id"), $db->f("property_name"), $db->f("property_description"), 
									$db->f("control_type"), $db->f("control_style"), $db->f("required"), 
									$db->f("use_on_list"), $db->f("use_on_details"), $db->f("use_on_checkout"),
									$db->f("start_html"), $db->f("middle_html"), $db->f("end_html"),
									$db->f("control_code"), $db->f("onchange_code"), $db->f("onclick_code"),
									$db->f("property_type_id"), $db->f("sub_item_id"), $db->f("additional_price"), 
									$db->f("use_on_second"), $db->f("property_order")
								);
							} while ($db->next_record());
				  
							$ip = new VA_Record($table_prefix . "items_properties");
							$ip->add_textbox("property_id", INTEGER);
							$ip->add_textbox("item_id", INTEGER);
							$ip->add_textbox("property_name", TEXT);
							$ip->add_textbox("property_description", TEXT);
							$ip->add_textbox("control_type", TEXT);
							$ip->add_textbox("control_style", TEXT);
							$ip->add_textbox("required", INTEGER);
							$ip->add_textbox("use_on_list", INTEGER);
							$ip->add_textbox("use_on_details", INTEGER);
							$ip->add_textbox("use_on_checkout", INTEGER);
							$ip->add_textbox("start_html", TEXT);
							$ip->add_textbox("middle_html", TEXT);
							$ip->add_textbox("end_html", TEXT);
							$ip->add_textbox("control_code", TEXT);
							$ip->add_textbox("onchange_code", TEXT);
							$ip->add_textbox("onclick_code", TEXT);
							$ip->add_textbox("property_type_id", INTEGER);
							$ip->add_textbox("sub_item_id", INTEGER);
							$ip->add_textbox("additional_price", FLOAT);
							$ip->add_textbox("use_on_second", INTEGER);
							$ip->add_textbox("property_order", INTEGER);
							$ip->set_value("item_id", $new_item_id);
							
							$ipv = new VA_Record($table_prefix . "items_properties_values");
							$ipv->add_textbox("property_id", INTEGER);
							$ipv->add_textbox("property_value", TEXT);
							$ipv->add_textbox("additional_price", NUMBER);
							$ipv->add_textbox("additional_weight", NUMBER);
							$ipv->add_textbox("hide_value", INTEGER);
							$ipv->add_textbox("is_default_value", INTEGER);
							$ipv->add_textbox("manufacturer_code", TEXT);
							$ipv->add_textbox("buying_price", NUMBER);
							$ipv->add_textbox("stock_level", INTEGER);
							$ipv->add_textbox("use_stock_level", INTEGER);
							$ipv->add_textbox("hide_out_of_stock", INTEGER);
							$ipv->add_textbox("download_path", TEXT);
							$ipv->add_textbox("download_period", INTEGER);
							$ipv->add_textbox("sub_item_id", INTEGER);
	  
				  
							for($i = 0; $i < sizeof($item_properties); $i++) {
								$property_id = $item_properties[$i][0];
								$db->query("SELECT MAX(property_id) FROM " . $table_prefix . "items_properties ");
								$db->next_record();
								$new_property_id = $db->f(0) + 1;
								$ip->set_value("property_id", $new_property_id);
								$ip->set_value("property_name", $item_properties[$i][1]);
								$ip->set_value("property_description", $item_properties[$i][2]);
								$ip->set_value("control_type", $item_properties[$i][3]);
								$ip->set_value("control_style", $item_properties[$i][4]);
								$ip->set_value("required", $item_properties[$i][5]);
								$ip->set_value("use_on_list", $item_properties[$i][6]);
								$ip->set_value("use_on_details", $item_properties[$i][7]);
								$ip->set_value("use_on_checkout", $item_properties[$i][8]);
								$ip->set_value("start_html", $item_properties[$i][9]);
								$ip->set_value("middle_html", $item_properties[$i][10]);
								$ip->set_value("end_html", $item_properties[$i][11]);
								$ip->set_value("control_code", $item_properties[$i][12]);
								$ip->set_value("onchange_code", $item_properties[$i][13]);
								$ip->set_value("onclick_code", $item_properties[$i][14]);
								$ip->set_value("property_type_id", $item_properties[$i][15]);
								$ip->set_value("sub_item_id", $item_properties[$i][16]);
								$ip->set_value("additional_price", $item_properties[$i][17]);
								$ip->set_value("use_on_second", $item_properties[$i][18]);
								$ip->set_value("property_order", $item_properties[$i][19]);
	  
								$ip->insert_record();
								// duplicate property values
								$property_values = array();
								$sql  = " SELECT * FROM " . $table_prefix . "items_properties_values ";
								$sql .= " WHERE property_id=" . $db->tosql($property_id, INTEGER);
								$db->query($sql);
								while ($db->next_record()) {
									$property_values[] = array($db->f("property_value"), $db->f("additional_price"), 
										$db->f("additional_weight"), $db->f("hide_value"), $db->f("is_default_value"),
										$db->f("manufacturer_code"), $db->f("buying_price"), $db->f("stock_level"),
										$db->f("use_stock_level"), $db->f("hide_out_of_stock"), $db->f("download_path"),
										$db->f("download_period"), $db->f("sub_item_id")
									);
								}
								for($pi = 0; $pi < sizeof($property_values); $pi++) {
									$ipv->set_value("property_id", $new_property_id);
									$ipv->set_value("property_value", $property_values[$pi][0]);
									$ipv->set_value("additional_price", $property_values[$pi][1]);
									$ipv->set_value("additional_weight", $property_values[$pi][2]);
									$ipv->set_value("hide_value", $property_values[$pi][3]);
									$ipv->set_value("is_default_value", $property_values[$pi][4]);
	  
									$ipv->set_value("manufacturer_code", $property_values[$pi][5]);
									$ipv->set_value("buying_price", $property_values[$pi][6]);
									$ipv->set_value("stock_level", $property_values[$pi][7]);
									$ipv->set_value("use_stock_level", $property_values[$pi][8]);
									$ipv->set_value("hide_out_of_stock", $property_values[$pi][9]);
									$ipv->set_value("download_path", $property_values[$pi][10]);
									$ipv->set_value("download_period", $property_values[$pi][11]);
									$ipv->set_value("sub_item_id", $property_values[$pi][12]);
	  
									$ipv->insert_record();
								}
							}
						}
					}
					// end of saving properties
	  
					// duplicate all releases
					if ($duplicate_releases == 1 && $record_updated) {
						$item_releases = array();
						$sql  = " SELECT * FROM " . $table_prefix . "releases ";
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$db->query($sql);
						if ($db->next_record()) {
							do {
								$item_releases[] = array($db->f("release_id"), $db->f("release_type_id"), $db->f("release_date", DATETIME), 
									$db->f("release_title"), $db->f("version"), $db->f("release_desc"), $db->f("download_type"),
									$db->f("path_to_file"), $db->f("is_showing"), $db->f("show_on_index"));
							} while ($db->next_record());
				  
							$ir = new VA_Record($table_prefix . "releases");
							$ir->add_textbox("release_id", INTEGER);
							$ir->add_textbox("item_id", INTEGER);
							$ir->add_textbox("release_type_id", INTEGER);
							$ir->add_textbox("release_date", DATETIME);
							$ir->add_textbox("release_title", TEXT);
							$ir->add_textbox("version", TEXT);
							$ir->add_textbox("release_desc", TEXT);
							$ir->add_textbox("download_type", INTEGER);
							$ir->add_textbox("path_to_file", TEXT);
							$ir->add_textbox("is_showing", INTEGER);
							$ir->add_textbox("show_on_index", INTEGER);
							$ir->set_value("item_id", $new_item_id);
							
							$irv = new VA_Record($table_prefix . "release_changes");
							$irv->add_textbox("release_id", INTEGER);
							$irv->add_textbox("change_type_id", INTEGER);
							$irv->add_textbox("change_date", DATETIME);
							$irv->add_textbox("change_desc", TEXT);
							$irv->add_textbox("is_showing", INTEGER);
				  
							for($i = 0; $i < sizeof($item_releases); $i++) {
								$release_id = $item_releases[$i][0];
								$db->query("SELECT MAX(release_id) FROM " . $table_prefix . "releases ");
								$db->next_record();
								$new_release_id = $db->f(0) + 1;
								$ir->set_value("release_id", $new_release_id);
								$ir->set_value("release_type_id", $item_releases[$i][1]);
								$ir->set_value("release_date", $item_releases[$i][2]);
								$ir->set_value("release_title", $item_releases[$i][3]);
								$ir->set_value("version", $item_releases[$i][4]);
								$ir->set_value("release_desc", $item_releases[$i][5]);
								$ir->set_value("download_type", $item_releases[$i][6]);
								$ir->set_value("path_to_file", $item_releases[$i][7]);
								$ir->set_value("is_showing", $item_releases[$i][8]);
								$ir->set_value("show_on_index", $item_releases[$i][9]);
								$ir->insert_record();
								// duplicate releases changes 
								$release_changes = array();
								$sql  = " SELECT * FROM " . $table_prefix . "release_changes ";
								$sql .= " WHERE release_id=" . $db->tosql($release_id, INTEGER);
								$db->query($sql);
								while ($db->next_record()) {
									$release_changes[] = array($db->f("change_type_id"), $db->f("change_date", DATETIME), 
										$db->f("change_desc"), $db->f("is_showing"));
								}
								for($pi = 0; $pi < sizeof($release_changes); $pi++) {
									$irv->set_value("release_id", $new_release_id);
									$irv->set_value("change_type_id", $release_changes[$pi][0]);
									$irv->set_value("change_date", $release_changes[$pi][1]);
									$irv->set_value("change_desc", $release_changes[$pi][2]);
									$irv->set_value("is_showing", $release_changes[$pi][3]);
									$irv->insert_record();
								}
							}
						}
					}
					// end of saving releases
	  
	  
				} else if(strlen($item_id)) {
					$record_updated = $r->update_record();
				} else {
					$db->query("SELECT MAX(item_id) FROM " . $table_prefix . "items");
					$db->next_record();
					$item_id = $db->f(0) + 1;
					$r->set_value("item_id", $item_id);
					$record_updated = $r->insert_record();
					if ($record_updated) {
						$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id,category_id) VALUES (";
						$sql .= $db->tosql($item_id, INTEGER) . ",";
						$sql .= $db->tosql($category_id, INTEGER) . ")";
						$db->query($sql);
						// set default properties if exists
						if($r->get_value("default_properties") > 0) {
							$return_page = "admin_properties_add.php?category_id=" . $category_id . "&item_id=" . urlencode($item_id);
							header("Location: " . $return_page);
							exit;
						}
					} else {
						$item_id = "";
						$r->set_value("item_id", "");
					}
				}

				if ($operation == "save") {
					// update serial numbers
					$is_eg->set_values("item_id", $item_id);
					$is_eg->update_all($number_serials);
				}
	  
				if ($record_updated) {
					header("Location: " . $return_page);
					exit;
				}
			}
		}
	}
	else if(strlen($item_id))
	{
		$r->get_db_values();

		// check data for serial numbers
		$is_eg->set_value("item_id", $item_id);
		$is_eg->change_property("serial_id", USE_IN_SELECT, true);
		$is_eg->change_property("serial_id", USE_IN_WHERE, false);
		$is_eg->change_property("item_id", USE_IN_WHERE, true);
		$is_eg->change_property("item_id", USE_IN_SELECT, true);
		$number_serials = $is_eg->get_db_values();
		if ($number_serials == 0) {
			$number_serials = 5;
		}

	}
	else // new record (set default values)
	{
		$sql  = " SELECT MAX(item_order) FROM " . $table_prefix . "items i, " . $table_prefix . "items_categories ic ";
		$sql .= " WHERE i.item_id=ic.item_id ";
		$sql .= " AND ic.category_id=" . $db->tosql($category_id, INTEGER);
		$item_order = get_db_value($sql);
		$item_order = ($item_order) ? ($item_order + 1) : 1;
		$r->set_value("item_order", $item_order);
		//$r->set_value("use_stock_level", 1);
		//$r->set_value("hide_out_of_stock", 1);
		$r->set_value("is_showing", 1);
		$r->set_value("full_desc_type", 0);
		$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "global_settings ";
		$sql .= " WHERE setting_type='default_property'";
		$db->query($sql);
		$db->next_record();
		$default_properties = $db->f(0);
		$r->set_value("default_properties", $default_properties);

		// serial numbers
		$number_serials = 5;
	}

	// round price for two digits
	if (!$r->is_empty("price")) {
		$r->set_value("price", round($r->get_value("price"), 2));
	}
	if (!$r->is_empty("sales_price")) {
		$r->set_value("sales_price", round($r->get_value("sales_price"), 2));
	}
	$r->set_form_parameters();

	// set errors
	if ($downloads_errors) {
		$t->set_var("errors_list", $downloads_errors);
		$t->parse("downloads_errors", false);
	}

	// set serial numbers
	$t->set_var("number_serials", $number_serials);
	$is_eg->set_parameters_all($number_serials);

	// set styles for tabs
	$tabs = array("general" => "General", "downloads" => "Downloadable / Software", "special_offer" => "Special Offer", "notifications" => "Notification", "other" => "Rating / Notes");
	foreach ($tabs as $tab_name => $tab_title) {
		$t->set_var("tab_id", "tab_" . $tab_name);
		$t->set_var("tab_name", $tab_name);
		$t->set_var("tab_title", $tab_title);
		if ($tab_name == $current_tab) {
			$t->set_var("tab_class", "tabActive");
			$t->set_var($tab_name . "_style", "display: block;");
		} else {
			$t->set_var("tab_class", "tab");
			$t->set_var($tab_name . "_style", "display: none;");
		}
		$t->parse("tabs", $tab_title);
	}
	$t->set_var("current_tab", $current_tab);


	if(strlen($item_id))	
	{
		$duplicate_properties    = ($duplicate_properties == 1) ? " checked " : "";
		$duplicate_specification = ($duplicate_specification == 1) ? " checked " : "";
		$duplicate_related       = ($duplicate_related == 1) ? " checked " : "";
		$duplicate_categories    = ($duplicate_categories == 1) ? " checked " : "";
		$duplicate_images        = ($duplicate_images == 1) ? " checked " : "";
		$duplicate_accessories   = ($duplicate_accessories == 1) ? " checked " : "";
		$duplicate_releases      = ($duplicate_releases == 1) ? " checked " : "";

		$t->set_var("duplicate_properties",    $duplicate_properties);
		$t->set_var("duplicate_specification", $duplicate_specification);
		$t->set_var("duplicate_related",       $duplicate_related);
		$t->set_var("duplicate_categories",    $duplicate_categories);
		$t->set_var("duplicate_images",        $duplicate_images);
		$t->set_var("duplicate_accessories",   $duplicate_accessories);
		$t->set_var("duplicate_releases",      $duplicate_releases);

		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
		$t->parse("duplicate", false);	
	}
	else
	{
		$t->set_var("save_button", "Add Product");
		$t->set_var("delete", "");	
		$t->set_var("duplicate", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>