<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  block_forum_topics.php                                   ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function forum_topics_show($block_name, $allowed_post_topics) 
{
	global $t, $db, $table_prefix, $settings;
	global $datetime_show_format, $date_modified;

	$user_id = get_session("session_user_id");		
	$forum_id = get_param("forum_id");
	$category_id = get_param("category_id");
	$sf = get_param("sf");
	$sw = trim(get_param("sw"));
	$u = get_param("u");
	if (!$forum_id && preg_match("/^f(\d+)$/i", $sf, $match)) {
		$forum_id = $match[1];
	} else if (!$category_id && preg_match("/^c(\d+)$/i", $sf, $match)) {
		$category_id = $match[1];
	}

	$t->set_file("block_body","block_forum_topics.html");
	$t->set_var("FORUM_TITLE",          FORUM_TITLE);
	$t->set_var("MY_ACCOUNT_MSG",       MY_ACCOUNT_MSG);
	$t->set_var("MY_FORUM_TOPICS_MSG",  MY_FORUM_TOPICS_MSG);
	$t->set_var("ALL_FORUM_TOPICS_MSG", ALL_FORUM_TOPICS_MSG);
	$t->set_var("MY_FORUM_TOPICS_DESC", MY_FORUM_TOPICS_DESC);
	$t->set_var("NEW_TOPIC_MSG",        NEW_TOPIC_MSG);
	$t->set_var("NO_TOPICS_MSG",        NO_TOPICS_MSG);

	$t->set_var("forum_href", "forum_categories.php");
	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("all_forum_href", "forum.php");
	$t->set_var("user_forum_href", "forum.php?u=1");

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "forum.php");
	$s->set_parameters(false, true, true, false);
	$s->set_default_sorting(5, "desc");
	$s->set_sorter(TOPIC_NAME_COLUMN, "sorter_topic", "1", "topic");
	$s->set_sorter(TOPIC_AUTHOR_COLUMN, "sorter_user_name", "2", "user_name");
	$s->set_sorter(TOPIC_VIEWS_COLUMN, "sorter_views", "3", "views");
	$s->set_sorter(TOPIC_REPLIES_COLUMN, "sorter_replies", "4", "replies");
	$s->set_sorter(TOPIC_UPDATED_COLUMN, "sorter_date_modified", "5", "date_modified");

	$sw = trim(get_param("sw"));

	$sql_where = " WHERE fl.forum_id=f.forum_id AND fc.category_id=fl.category_id ";		
	if (strlen($user_id)) {
		$sql_where .= " AND fl.allowed_view IN (1,2) AND fl.allowed_view_topics IN (1,2) ";
	} else {
		$sql_where .= " AND fl.allowed_view=1 AND fl.allowed_view_topics=1 ";
	}
	if ($category_id) {
		$sql_where .= " AND fc.category_id=" . $db->tosql($category_id, INTEGER);
	} else if (preg_match("/^c(\d+)$/i", $sf, $match)) {
		$sql_where .= " AND fc.category_id=" . $db->tosql($match[1], INTEGER);
	}
	if ($forum_id) {
		$sql_where .= " AND fl.forum_id=" . $db->tosql($forum_id, INTEGER);
	} else if (preg_match("/^f(\d+)$/i", $sf, $match)) {
		$sql_where .= " AND fl.forum_id=" . $db->tosql($match[1], INTEGER);
	}
	if ($u && strlen(get_session("session_user_id"))) {
		$sql_where .= " AND user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
	}
	if (strlen($sw)) {
		$search_values = split(" ", $sw);
		for($si = 0; $si < sizeof($search_values); $si++) {
			$sql_where .= " AND (";
			$sql_where .= " f.topic LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%' ";
			$sql_where .= " OR f.description LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%' ";
			$sql_where .= " ) ";
		}
	}

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "forum.php");
	$n->set_parameters(false, true, false);

	$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "forum f, ";
	$sql .= $table_prefix . "forum_list fl, ";
	$sql .= $table_prefix . "forum_categories fc ";
	// set up variables for navigator
	$db->query($sql . $sql_where);
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 10;
	$page_number = $n->set_navigator("navigator", "page", CENTERED, $pages_number, $records_per_page, $total_records, false);

	$sql  = " SELECT f.* FROM " . $table_prefix . "forum f, ";
	$sql .= $table_prefix . "forum_list fl, ";
	$sql .= $table_prefix . "forum_categories fc ";
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql . $sql_where . $s->order_by);
	if($db->next_record())
	{
		$t->set_var("no_records", "");
		$t->parse("sorters", false);
		do
		{
			$thread_id = $db->f("thread_id");
			$forum_topic_url = "forum_topic.php?thread_id=" . $thread_id;
			$t->set_var("forum_thread_href", $forum_topic_url);
			$t->set_var("thread_id", $thread_id);
			$t->set_var("topic", htmlspecialchars($db->f("topic")));
			$t->set_var("user_name", htmlspecialchars($db->f("user_name")));
			$t->set_var("views", intval($db->f("views")));
			$t->set_var("replies", intval($db->f("replies")));
			$date_modified = $db->f("date_modified", DATETIME);
			$t->set_var("date_modified", va_date($datetime_show_format, $date_modified));
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	if ($allowed_post_topics == 1 || ($allowed_post_topics == 2 && strlen($user_id))) {
		$forum_topic_new_url = "forum_topic_new.php?forum_id=" . urlencode($forum_id);
		$t->set_var("forum_topic_new_url", $forum_topic_new_url);
		$t->parse("new_topic_block", false);
	}

	// show search results information
	if(strlen($sw) || $u) {
		$found_message = str_replace("{found_records}", $total_records, FOUND_TOPICS_MSG);
		$found_message = str_replace("{search_string}", htmlspecialchars($sw), $found_message);
		$t->set_var("found_message", $found_message);
		$t->parse("search_results", false);
	} 

	$t->parse("block_body", false);
	$t->parse($block_name, true);
}

?>