<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  block_products_top_rated.php                             ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function top_products($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $category_id, $language_code;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$t->set_file("block_body", "block_top_rated.html");
	$t->set_var("top_category_name",PRODUCTS_TITLE);
	$t->set_var("TOP_RATED_TITLE",  TOP_RATED_TITLE);
	$t->set_var("top_rated_items",  "");

	$sql  = " SELECT i.item_id, i.item_name, i.rating ";
	$sql .= " FROM " . $table_prefix . "items i, " . $table_prefix . "items_categories ic";
	$sql .= " WHERE i.item_id=ic.item_id ";
	$sql .= " AND i.is_showing=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " AND i.votes>=" . $db->tosql(get_setting_value($settings, "min_votes", 10), INTEGER);
	$sql .= " AND i.rating>=" . $db->tosql(get_setting_value($settings, "min_rating", 1), FLOAT);
	$sql .= " GROUP BY i.item_id, i.item_name, i.rating, i.item_order ";
	$sql .= " ORDER BY i.rating DESC, i.item_order, i.item_name  ";

	$db->RecordsPerPage = 10;
	$db->PageNumber = 1;
	$db->query($sql);
	if($db->next_record())
	{
		$item_number = 0;
		do
		{
			$item_number++;
			$item_id = $db->f("item_id");
			$item_name = get_translation($db->f("item_name"));
			$details_href = "product_details.php?item_id=".urlencode($item_id);

			$t->set_var("details_href", $details_href);
			$t->set_var("top_position", $item_number);
			$t->set_var("top_name", $item_name);
			$t->set_var("top_rating", number_format($db->f("rating"), 2));

			$t->parse("top_rated_items", true);
		} while ($db->next_record());              	
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>